regina::NFileInfo Class Reference
File I/O

Stores information about a Regina data file, including file type and version. More...

`#include <file/nfileinfo.h>`

Inheritance diagram for regina::NFileInfo:

## Public Member Functions

const std::string & | getPathname () const
| Returns the pathname of the data file being described. More...
int | getType () const
| Returns the type of data file. More...
const std::string & | getTypeDescription () const
| Returns a human-readable description of the type of data file. More...
const std::string & | getEngine () const
| Returns the version of the calculation engine that wrote this file. More...
bool | isCompressed () const
| Returns whether this file is stored in compressed format. More...
bool | isInvalid () const
| Returns whether the file metadata could not be read. More...
void | writeTextShort (std::ostream &out) const
| Writes this object in short text format to the given output stream. More...
void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
Public Member Functions inherited from regina::ShareableObject
| ShareableObject ()
| Default constructor that does nothing. More...
virtual | ~ShareableObject ()
| Default destructor that does nothing. More...
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...

## Static Public Member Functions

static NFileInfo * | identify (const std::string &idPathname)
| Return information about the given Regina data file. More...

## Static Public Attributes

static const int | TYPE_XML
| Represents a new-style XML data file. More...

## Additional Inherited Members

Protected Member Functions inherited from regina::boost::noncopyable
| noncopyable ()
| A constructor which does nothing. More...
| ~noncopyable ()
| A destructor which does nothing. More...

## Detailed Description

Stores information about a Regina data file, including file type and version.

Routine identify() can be used to determine this information for a given file.

As of Regina 4.94, the old-style binary files are no longer supported. These have not been in use for over a decade. The only file type that this class now recognises is TYPE_XML (compressed or uncompressed XML data files).

## Member Function Documentation

const std::string & regina::NFileInfo::getEngine | ( |  | ) | const

inline

Returns the version of the calculation engine that wrote this file.

Returns
  the engine version for this file.

const std::string & regina::NFileInfo::getPathname | ( |  | ) | const

inline

Returns the pathname of the data file being described.

Internationalisation:
  The character encoding used in the pathname will be whatever was originally passed to identify(). This might or might not be UTF-8, since it needs to be understood by the low-level C/C++ file I/O routines.

Returns
  the pathname.

int regina::NFileInfo::getType | ( |  | ) | const

inline

Returns the type of data file.

The type will be given as one of the file type constants defined in this class.

Returns
  the type of data file.

const std::string & regina::NFileInfo::getTypeDescription | ( |  | ) | const

inline

Returns a human-readable description of the type of data file.

Returns
  a description of the type of data file.

static NFileInfo* regina::NFileInfo::identify | ( | const std::string & | idPathname | ) |

static

Return information about the given Regina data file.

Internationalisation:
  This routine makes no assumptions about the character encoding used in the given path name, and simply passes it through unchanged to low-level C/C++ file I/O routines. If an NFileInfo structure is returned, its getPathname() routine will use the same encoding that is passed here.

Parameters

  idPathname | the pathname of the data file to be examined.

Returns
  a newly created NFileInfo structure containing information about the given file, or 0 if the file type could not be identified.

bool regina::NFileInfo::isCompressed | ( |  | ) | const

inline

Returns whether this file is stored in compressed format.

Currently this option only applies to XML data files.

Returns
  `true` if this file is compressed or `false` otherwise.

bool regina::NFileInfo::isInvalid | ( |  | ) | const

inline

Returns whether the file metadata could not be read.

Returns
  `true` if the metadata could not be read, `false` otherwise.

void regina::NFileInfo::writeTextLong | ( | std::ostream & | out | ) | const

virtual

Writes this object in long text format to the given output stream.

The output should provide the user with all the information they could want. The output should be human-readable, should not contain extremely long lines (so users can read the output in a terminal), and should end with a final newline.

The default implementation of this routine merely calls writeTextShort() and adds a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Reimplemented from regina::ShareableObject.

void regina::NFileInfo::writeTextShort | ( | std::ostream & | out | ) | const

virtual

Writes this object in short text format to the given output stream.

The output should be human-readable, should fit on a single line, and should not end with a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Implements regina::ShareableObject.

## Member Data Documentation

const int regina::NFileInfo::TYPE_XML

static

Represents a new-style XML data file.

The documentation for this class was generated from the following file:

- file/nfileinfo.h

Copyright © 1999-2013, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).